/*
 * Proyecto: prueba
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 20/02/2004
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oButton1
   COMPONENT oLabel1
   COMPONENT oDBEdit1
   COMPONENT oLabel2
   COMPONENT oDBEdit2
   COMPONENT oDBEdit3
   COMPONENT oLabel3
   COMPONENT oDBEdit4
   COMPONENT oLabel4
   COMPONENT oLabel5
   COMPONENT oDBMemo1
   COMPONENT oLabel6
   COMPONENT oDBComboBox1
   COMPONENT oDBLabel1
   COMPONENT oLabel7
   COMPONENT oDBComboBox2
   COMPONENT oLabel8
   COMPONENT oDBComboBox3
   COMPONENT oLabel9
   COMPONENT oDBDatePicker1
   COMPONENT oDBBrowse1
   COMPONENT oDBBrowse1Column1
   COMPONENT oCheckbox1
   COMPONENT oDBBrowse1Column2
   COMPONENT oButton2
   COMPONENT oButton3
   COMPONENT oButton4
   COMPONENT oLabel10
   COMPONENT oCdxDataSource1
   COMPONENT oRS
   COMPONENT oDBSwitch1

   METHOD CreateForm() CONSTRUCTOR
   METHOD Button1Click( oSender )
   METHOD DBComboBox1Create( oSender )
   METHOD FormInitialize( oSender )
   METHOD Checkbox1Change( oSender )
   METHOD Button2Click( oSender )
   METHOD Button3Click( oSender )
   METHOD Button4Click( oSender )
   METHOD DBBrowse1Change( oSender, lBookMarkChanged )
   METHOD RSPostOpen( oSender )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD Button1Click( oSender ) CLASS TForm1

   WITH OBJECT ::oRS
      IF !:lOnEdit()
         ::oDbBrowse1:lEnabled := .f.
         :Edit()
         ::oButton1:cText := "Update"
         ::oButton2:cText := "Cancel"
         ::oButton3:lVisible  := .F.
         ::oDbEdit1:SetFocus()
      ELSE
         :Update()
         ::oButton1:cText := "Edit"
         ::oButton2:cText := "Add New"
         ::oButton3:lVisible  := .T.
         ::oDbBrowse1:lEnabled := .t.
         ::oDbBrowse1:RefreshCurrent()
         ::oDbBrowse1:SetFocus()
      ENDIF
   END WITH

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button2Click( oSender ) CLASS TForm1

   WITH OBJECT ::oRS
      IF !:lOnEdit()
         ::oDbBrowse1:lEnabled := .f.
         :AddNew()
         ::oButton1:cText := "Update"
         ::oButton2:cText := "Cancel"
         ::oButton3:lVisible  := .F.
         ::oDbEdit1:SetFocus()
      ELSE
         :Cancel()
         ::oButton1:cText := "Edit"
         ::oButton2:cText := "Add New"
         ::oButton3:lVisible  := .T.
         ::oDbBrowse1:lEnabled := .t.
         ::oDbBrowse1:RefreshCurrent()
         ::oDbBrowse1:SetFocus()
      ENDIF
   END WITH

RETURN Nil

//------------------------------------------------------------------------------

METHOD DBComboBox1Create( oSender ) CLASS TForm1

   //oSender:aItems := ::oRS:SaveToArray( "state" )

RETURN Nil

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TForm1

   SET EPOCH TO 1950
   SET DELETED ON

RETURN Nil

//------------------------------------------------------------------------------

METHOD Checkbox1Change( oSender ) CLASS TForm1

   ::oDbBrowse1:lFilterBar := oSender:lChecked

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button3Click( oSender ) CLASS TForm1

   ::oRS:Delete()

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button4Click( oSender ) CLASS TForm1

   LOCAL cTemp
   LOCAL nSec, nRec

   nSec := Seconds()
   nRec := 0

   WITH OBJECT ::oRS
      :SaveState( .T. )
      :Gotop()
      DO WHILE !:Eof()
         ::oLabel10:cText := "Procesando registro: " + ToString( ++nRec )
         ProcessMessages()
         :FastEdit()
         cTemp := :FieldGet( 1 )
         :FieldPut( 1, :FieldGet( 2 ) )
         :FieldPut( 2, cTemp )
         :FastUpdate()
         :Skip()
      ENDDO
      :RestoreState( .T. )
      :Refresh()
   END WITH

   ::oLabel10:cText := "Tiempo: " + ToString( Seconds() - nSec )

RETURN Nil

//------------------------------------------------------------------------------

METHOD DBBrowse1Change( oSender, lBookMarkChanged ) CLASS TForm1

   WITH OBJECT ::oRS
   END WITH

RETURN Nil

//------------------------------------------------------------------------------

METHOD RSPostOpen( oSender ) CLASS TForm1

   oSender:OrdSetFocus( 0 )
   oSender:GoTop()

RETURN Nil

//------------------------------------------------------------------------------
